Overview_Settings = class(Turbine.UI.Window)
 
function Overview_Settings:Constructor()

  Turbine.UI.Window.Constructor(self)
	self:SetSize(80, 16)
	self:SetPosition(overviewWindow:GetLeft() + overviewWindow:GetWidth() - self:GetWidth(), overviewWindow:GetTop())

	self.chatButtonContainer = Turbine.UI.Control()
	self.chatButtonContainer:SetParent(self)
	self.chatButtonContainer:SetSize(16,16)

	self.chatSend = Turbine.UI.Lotro.Quickslot()
	self.chatSend:SetParent(self.chatButtonContainer)
	self.chatSend:SetSize(self.chatButtonContainer:GetSize())
	self.chatSend:SetUseOnRightClick(false)
	self.chatSend.MouseDown = function(sender,args)
    if args.Button == Turbine.UI.MouseButton.Right then
      self.contextMenu.x, self.contextMenu.y = Turbine.UI.Display.GetMousePosition()
      self.contextMenu:ShowMenu()
    end
	end
  
	self.chatButtonOverlay = Turbine.UI.Control()
	self.chatButtonOverlay:SetParent(self.chatButtonContainer)
	self.chatButtonOverlay:SetSize(self.chatButtonContainer:GetSize())
	self.chatButtonOverlay:SetBackground("PvMP_Plus/Resources/chat.tga")
	self.chatButtonOverlay:SetMouseVisible(false)

	self.contextMenu = Turbine.UI.ContextMenu()
	self.contextMenu.menuItems = self.contextMenu:GetItems()
	if data.numbers.selectedChannel == nil then
		data.numbers.selectedChannel = 5 -- 1 = say, 2 = fellow, 3 = raid, 4 = kin, 5 = OOC, 6 = uc1, 7 = uc2, 8 = uc3, 9 = uc4
	end

  for i = 1, #L.ChatChannels do
    self.contextMenu[i] = Turbine.UI.MenuItem(L.ChatChannels[i][2],true,data.numbers.selectedChannel == i)
    self.contextMenu[i].Click = function(sender)
      for j = 1, #L.ChatChannels do	self.contextMenu.menuItems:Get(j):SetChecked(false) end
      sender:SetChecked(true)
      data.numbers.selectedChannel = i
      self:UpdateChatData()
    end
    self.contextMenu.menuItems:Add(self.contextMenu[i])
  end
  
	if storage.chat_total == nil then storage.chat_total = false end
	self.contextMenu.total = Turbine.UI.MenuItem(L.Menu[1],true,storage.chat_total)
	self.contextMenu.total.Click = function()
		self.contextMenu.total:SetChecked(not self.contextMenu.total:IsChecked())
		storage.chat_total = self.contextMenu.total:IsChecked()
		self.contextMenu:ShowMenuAt(self.contextMenu.x, self.contextMenu.y)
		self:UpdateChatData()
	end
	
	if storage.chat_rankup == nil then storage.chat_rankup = false end
	self.contextMenu.rankup = Turbine.UI.MenuItem(L.Menu[2],true,storage.chat_rankup)
	self.contextMenu.rankup.Click = function()
		self.contextMenu.rankup:SetChecked(not self.contextMenu.rankup:IsChecked())
		storage.chat_rankup = self.contextMenu.rankup:IsChecked()
		self.contextMenu:ShowMenuAt(self.contextMenu.x, self.contextMenu.y)
		self:UpdateChatData()
	end
	
	if storage.chat_day == nil then storage.chat_day = true end
	self.contextMenu.day = Turbine.UI.MenuItem(L.Menu[3],true,storage.chat_day)
	self.contextMenu.day.Click = function()
		self.contextMenu.day:SetChecked(not self.contextMenu.day:IsChecked())
		storage.chat_day = self.contextMenu.day:IsChecked()
		self.contextMenu:ShowMenuAt(self.contextMenu.x, self.contextMenu.y)
		self:UpdateChatData()
	end
	
	if storage.chat_hour == nil then storage.chat_hour = true end
	self.contextMenu.hour = Turbine.UI.MenuItem(L.Menu[4],true,storage.chat_hour)
	self.contextMenu.hour.Click = function()
		self.contextMenu.hour:SetChecked(not self.contextMenu.hour:IsChecked())
		storage.chat_hour = self.contextMenu.hour:IsChecked()
		self.contextMenu:ShowMenuAt(self.contextMenu.x, self.contextMenu.y)
		self:UpdateChatData()
	end
	
	if storage.chat_tenmin == nil then storage.chat_tenmin = true end
	self.contextMenu.tenmin = Turbine.UI.MenuItem(L.Menu[5],true,storage.chat_tenmin)
	self.contextMenu.tenmin.Click = function()
		self.contextMenu.tenmin:SetChecked(not self.contextMenu.tenmin:IsChecked())
		storage.chat_tenmin = self.contextMenu.tenmin:IsChecked()
		self.contextMenu:ShowMenuAt(self.contextMenu.x, self.contextMenu.y)
		self:UpdateChatData()
	end
	
	if storage.chat_fight == nil then storage.chat_fight = false end
	self.contextMenu.fight = Turbine.UI.MenuItem(L.Menu[6],true,storage.chat_fight)
	self.contextMenu.fight.Click = function()
		self.contextMenu.fight:SetChecked(not self.contextMenu.fight:IsChecked())
		storage.chat_fight = self.contextMenu.fight:IsChecked()
		self.contextMenu:ShowMenuAt(self.contextMenu.x, self.contextMenu.y)
		self:UpdateChatData()
	end
	
	self.contextMenu.menuItems:Add(Turbine.UI.MenuItem(L.Gap,false))
	self.contextMenu.menuItems:Add(self.contextMenu.total)
	self.contextMenu.menuItems:Add(self.contextMenu.rankup)
	self.contextMenu.menuItems:Add(self.contextMenu.day)
	self.contextMenu.menuItems:Add(self.contextMenu.hour)
	self.contextMenu.menuItems:Add(self.contextMenu.tenmin)
	self.contextMenu.menuItems:Add(self.contextMenu.fight)
	
	self.plusminus = Turbine.UI.Control()
	self.plusminus:SetParent(self)
	self.plusminus:SetSize(16,16)
	self.plusminus:SetPosition(64,0)
	if storage.minimized then
		self.plusminus:SetBackground("PvMP_Plus/Resources/plus.tga") --0x41007e27
	else
		self.plusminus:SetBackground("PvMP_Plus/Resources/minus.tga") --0x41007e26
	end
	self.plusminus.MouseDown = function(sender,args)
    storage.minimized = overviewWindow.panel:IsVisible()
    overviewWindow.panel:SetVisible(not storage.minimized)
    secondaryWindow:SetVisible((not storage.minimized) and (not storage.secondaryMinimized))
    if storage.minimized then
      self.plusminus:SetBackground("PvMP_Plus/Resources/plus.tga")
    else
      self.plusminus:SetBackground("PvMP_Plus/Resources/minus.tga")
    end
	end
	
  self.more_stats = Turbine.UI.Control()
	self.more_stats:SetParent(self)
	self.more_stats:SetSize(16, 16)
	self.more_stats:SetPosition(16, 0)
	self.more_stats:SetBackground("PvMP_Plus/Resources/statistics.tga")
	self.more_stats.MouseDown = function(sender,args)
    statsWindow:SetVisible(not statsWindow:IsVisible())
    if statsWindow:IsVisible() then
      statsWindow.tab_stats:Click()
      statsWindow.tab_stats:MouseLeave()
    end
	end
  
	self.secondaryWindow = Turbine.UI.Control()
	self.secondaryWindow:SetParent(self)
	self.secondaryWindow:SetSize(16, 16)
	self.secondaryWindow:SetPosition(32, 0)
	self.secondaryWindow:SetBackground("PvMP_Plus/Resources/secWindow.tga")
	self.secondaryWindow.MouseDown = function(sender,args)
    storage.secondaryMinimized =  not storage.secondaryMinimized
    secondaryWindow:SetVisible((not storage.minimized) and (not storage.secondaryMinimized))
	end

	self.settings = Turbine.UI.Control()
	self.settings:SetParent(self)
	self.settings:SetSize(16, 16)
	self.settings:SetPosition(48, 0)
	self.settings:SetBackground("PvMP_Plus/Resources/settings_button.tga")
	self.settings.MouseDown = function(sender,args)
    settings:SetVisible(not settings:IsVisible())
	end
	
	self:SetZOrder(1)
	
end

function Overview_Settings:UpdateChatData()

	local gold  = "#DAA520"
	local red   = "#FF3232"
	local beige = "#FFFF99"
  
  local shortcut = Turbine.UI.Lotro.Shortcut(
    Turbine.UI.Lotro.ShortcutType.Alias,
    "/"..
    (data.numbers.selectedChannel == 1 and L.ChatChannels[1][1] or
    data.numbers.selectedChannel == 2 and L.ChatChannels[2][1] or
    data.numbers.selectedChannel == 3 and L.ChatChannels[3][1] or
    data.numbers.selectedChannel == 4 and L.ChatChannels[4][1] or
    data.numbers.selectedChannel == 5 and L.ChatChannels[5][1] or
    data.numbers.selectedChannel == 6 and L.ChatChannels[6][1] or
    data.numbers.selectedChannel == 7 and L.ChatChannels[7][1] or
    data.numbers.selectedChannel == 8 and L.ChatChannels[8][1] or
    L.ChatChannels[9][1]).." "..
    "<rgb="..gold..">"..L.Points_Type..": </rgb>"..
    (storage.chat_total  and "<rgb="..red..">"..L.Total..           "</rgb>".."<rgb="..beige..">"..FormatPoints(data.numbers.points_total)..      "</rgb> " or "")..
    (storage.chat_rankup and "<rgb="..red..">"..L.RankUp..          "</rgb>".."<rgb="..beige..">"..FormatPoints(GetRemainingPoints())..              "</rgb> " or "")..
    (storage.chat_day    and "<rgb="..red..">"..L.Today..           "</rgb>".."<rgb="..beige..">"..FormatPoints(data.numbers.points_current_day).."</rgb> " or "")..
    (storage.chat_hour   and "<rgb="..red..">"..L.Stats_Last_Hour.. "</rgb>".."<rgb="..beige..">"..FormatPoints(GetPointsLastHour())..               "</rgb> " or "")..
    (storage.chat_tenmin and "<rgb="..red..">"..L.Stats_Last_10min.."</rgb>".."<rgb="..beige..">"..FormatPoints(GetPointsLast10min())..              "</rgb> " or "")..
    (storage.chat_fight  and "<rgb="..red..">"..L.Stats_Last_Fight.."</rgb>".."<rgb="..beige..">"..FormatPoints(points_last_fight)..                 "</rgb> " or "")
  )
  self.chatSend:SetShortcut(shortcut)
  self.chatSend:SetAllowDrop(false)
end