SecondaryWindow = class(Turbine.UI.Window)

function SecondaryWindow:Constructor()

  local width = 140
  local height = 179

  Turbine.UI.Window.Constructor(self)
  
  self:SetSize(width,height)
  self:SetPosition(data.numbers.secondaryWin_x, data.numbers.secondaryWin_y)
	self:SetMouseVisible(false)
  self:SetOpacity(0.9)

  self.DragBar = DragBar(self, "PvMP+ HelperWindow") --TODO namen

  self.panel = Turbine.UI.Control()
  self.panel:SetParent(self)
  self.panel:SetSize(width, height-20)
  self.panel:SetTop(20)
  self.panel:SetBackColor(Turbine.UI.Color.Black)
	self.panel:SetMouseVisible(false)

  self.amount_label = Turbine.UI.Label()
  self.amount_label:SetParent(self.panel)
  self.amount_label:SetSize(55, 20)
  self.amount_label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
  self.amount_label:SetPosition(5,5)
  self.amount_label:SetForeColor(default_font_color)
  self.amount_label:SetFont(Turbine.UI.Lotro.Font.TrajanPro15)
  self.amount_label:SetText(L.Amount)
  self.amount_label:SetMouseVisible(false)

  self.amount_box = Turbine.UI.Lotro.TextBox()
  self.amount_box:SetParent(self.panel)
  self.amount_box:SetSize(25, 20)
  self.amount_box:SetPosition(self.amount_label:GetWidth() + 5,5)
  self.amount_box:SetForeColor(default_font_color)
  self.amount_box:SetFont(Turbine.UI.Lotro.Font.TrajanPro15)
  self.amount_box:SetMultiline(false)
  self.amount_box.oldText = ""

  self.amount_box.FocusGained = function() self.amount_box:SetWantsUpdates(true)  end
  self.amount_box.FocusLost   = function() self.amount_box:SetWantsUpdates(false) end
  self.amount_box.Update = function()
    if self.amount_box.oldText ~= self.amount_box:GetText() then
      if tonumber(self.amount_box:GetText()) == nil then 
        if self.amount_box:GetText() == "" then
          self.amount_box.oldText = self.amount_box:GetText()
          self:UpdateChatData()
        else
          self.amount_box:SetText(self.amount_box.oldText)
        end
        return
      end
      self.amount_box.oldText = self.amount_box:GetText()
      if tonumber(self.amount_box.oldText) > 99 and self.amount_box.oldText ~= "" then
        self.amount_box:SetText(math.floor(tonumber(self.amount_box.oldText)/10))
      end
      self:UpdateChatData()
    end
  end
  
  self.enemyLocContainer = Turbine.UI.Control()
	self.enemyLocContainer:SetParent(self.panel)
	self.enemyLocContainer:SetSize(45,20)
	self.enemyLocContainer:SetPosition(self:GetWidth() - self.enemyLocContainer:GetWidth() - 5,5)

	self.enemyLocQS = Turbine.UI.Lotro.Quickslot()
	self.enemyLocQS:SetParent(self.enemyLocContainer)
	self.enemyLocQS:SetSize(self.enemyLocContainer:GetSize())
	self.enemyLocQS:SetUseOnRightClick(false)
	self.enemyLocQS.MouseDown = function(sender,args)
    if args.Button == Turbine.UI.MouseButton.Right then
      self.contextMenu:ShowMenu()
    end
	end

  self.enemyLocOverlayBack=Turbine.UI.Control()
	self.enemyLocOverlayBack:SetParent(self.enemyLocContainer)
	self.enemyLocOverlayBack:SetSize(self.enemyLocContainer:GetSize())
  self.enemyLocOverlayBack:SetBackColor(default_font_color)
  self.enemyLocOverlayBack:SetMouseVisible(false)
  
	self.enemyLocOverlay=Turbine.UI.Label()
	self.enemyLocOverlay:SetParent(self.enemyLocContainer)
	self.enemyLocOverlay:SetSize(self.enemyLocContainer:GetWidth()-2, self.enemyLocContainer:GetHeight()-2)
  self.enemyLocOverlay:SetPosition(1,1)
  self.enemyLocOverlay:SetFont(Turbine.UI.Lotro.Font.Verdana12)
  self.enemyLocOverlay:SetBackColor(Turbine.UI.Color.Black)
	self.enemyLocOverlay:SetForeColor(default_font_color)
  self.enemyLocOverlay:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  self.enemyLocOverlay:SetText(L.Send)
  self.enemyLocOverlay:SetMouseVisible(false)
  
	self.contextMenu = Turbine.UI.ContextMenu()
	self.contextMenu.menuItems = self.contextMenu:GetItems()
	if data.numbers.selectedChannel2 == nil then
		data.numbers.selectedChannel2 = 5 -- 1 = say, 2 = fellow, 3 = raid, 4 = kin, 5 = OOC, 6 = uc1, 7 = uc2, 8 = uc3, 9 = uc4
	end
  
  for i = 2, #L.ChatChannels do
    self.contextMenu[i] = Turbine.UI.MenuItem(L.ChatChannels[i][2],true,data.numbers.selectedChannel2 == i)
    self.contextMenu[i].Click = function(sender)
      for j = 1, #L.ChatChannels - 1 do	self.contextMenu.menuItems:Get(j):SetChecked(false) end
      sender:SetChecked(true)
      data.numbers.selectedChannel2 = i
      self:UpdateChatData()
    end
    self.contextMenu.menuItems:Add(self.contextMenu[i])
  end

  self.recent_kills_panel = Turbine.UI.Control()
	self.recent_kills_panel:SetParent(self.panel)
	self.recent_kills_panel:SetSize(self.panel:GetWidth() - 10, 100)
  self.recent_kills_panel:SetBackColor(default_font_color)
  self.recent_kills_panel:SetMouseVisible(false)
  self.recent_kills_panel:SetPosition(5,32)

  self.recent_kills_label = Turbine.UI.Label()
  self.recent_kills_label:SetParent(self.recent_kills_panel)
  self.recent_kills_label:SetSize(self.recent_kills_panel:GetWidth() - 2, 20)
  self.recent_kills_label:SetPosition(1,1)
  self.recent_kills_label:SetBackColor(Turbine.UI.Color.Black)
  self.recent_kills_label:SetForeColor(default_font_color)
  self.recent_kills_label:SetFont(Turbine.UI.Lotro.Font.TrajanPro15)
  self.recent_kills_label:SetFontStyle(Turbine.UI.FontStyle.Outline)
  self.recent_kills_label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  self.recent_kills_label:SetText(L.RecentKills)
  self.recent_kills_label:SetMouseVisible(false)

  self.recent_kills = Turbine.UI.ListBox()
  self.recent_kills:SetParent(self.recent_kills_panel)
  self.recent_kills:SetSize(self.recent_kills_panel:GetWidth()-2, self.recent_kills_panel:GetHeight()-22)
  self.recent_kills:SetPosition(1,21)
  self.recent_kills:SetBackColor(Turbine.UI.Color(48/255,48/255,48/255))
  self.recent_kills.maxEntries = 5
  self.recent_kills:SetMouseVisible(false)
  self:InitRecentKillsList()
  
  self.showhide = Turbine.UI.Lotro.Button()
  self.showhide:SetParent(self.panel)
  self.showhide:SetWidth(width - 10)
  self.showhide:SetPosition(5, 135)
  self.showhide:SetText(L.ShowMap)
  self.showhide.Click = function()
    mapWindow:SetVisible(not mapWindow:IsVisible())
    if mapWindow:IsVisible() then
      self.showhide:SetText(L.HideMap)
    else
      self.showhide:SetText(L.ShowMap)
    end
  end

  self.VisibleChanged = function(sender)
    if not sender:IsVisible() then
      mapWindow:SetVisible(false)
      self.showhide:SetText(L.ShowMap)
    end
  end
  
  self.PositionChanged = function(sender, args)
		data.numbers.secondaryWin_x = self:GetLeft()
		data.numbers.secondaryWin_y = self:GetTop()
  end

  self:ShowRecentKills(not storage.show_recent_kills_disabled)
  self:UpdateChatData()
end

function SecondaryWindow:InitRecentKillsList()

  for i = 1, 5 do
  listItem = self:GetRecentKillsListItem(storage.last5kills[tostring(i)])
    self.recent_kills:InsertItem(1, listItem)
  end
end

function SecondaryWindow:NewRecentKill(name)

  for i = 1, 4 do
    storage.last5kills[tostring(i)] = storage.last5kills[tostring(i + 1)]
  end
  storage.last5kills["5"] = name

  if self.recent_kills:GetItemCount() == self.recent_kills.maxEntries then
    self.recent_kills:RemoveItemAt(self.recent_kills:GetItemCount())
  end

  listItem = self:GetRecentKillsListItem(name)
  self.recent_kills:InsertItem(1, listItem)
end

function SecondaryWindow:GetRecentKillsListItem(name)

  local item = Turbine.UI.Label()
  item:SetFont(Turbine.UI.Lotro.Font.Verdana14)
  item:SetSize(self.recent_kills:GetWidth(), self.recent_kills:GetHeight()/self.recent_kills.maxEntries)
  item:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  item:SetMouseVisible(false)
  item:SetText(name)
  return item
end

function SecondaryWindow:UpdateChatData()

  local amount = self.amount_box:GetText()
  local nospace = amount == ""
  local shortcut = Turbine.UI.Lotro.Shortcut(
    Turbine.UI.Lotro.ShortcutType.Alias,
    "/"..
    (data.numbers.selectedChannel2 == 2 and L.ChatChannels[2][1] or
    data.numbers.selectedChannel2 == 3 and L.ChatChannels[3][1] or
    data.numbers.selectedChannel2 == 4 and L.ChatChannels[4][1] or
    data.numbers.selectedChannel2 == 5 and L.ChatChannels[5][1] or
    data.numbers.selectedChannel2 == 6 and L.ChatChannels[6][1] or
    data.numbers.selectedChannel2 == 7 and L.ChatChannels[7][1] or
    data.numbers.selectedChannel2 == 8 and L.ChatChannels[8][1] or
    L.ChatChannels[9][1]).." <rgb="..posChatColor..">"..amount..(nospace and "" or " ")..
    (amount == "1" and L.FreepCreep or L.FreepsCreeps).." @ "..L.Loc2.."</rgb>"
  )

  self.enemyLocQS:SetShortcut(shortcut)
  self.enemyLocQS:SetAllowDrop(false)
end

function SecondaryWindow:ShowRecentKills(show)

  if show then
    self:SetHeight(179)
    self.panel:SetHeight(159)
    self.recent_kills_panel:SetVisible(true)
    self.showhide:SetTop(135)
  else
    self:SetHeight(179-self.recent_kills_panel:GetHeight() - 5)
    self.panel:SetHeight(159-self.recent_kills_panel:GetHeight() - 5)
    self.recent_kills_panel:SetVisible(false)
    self.showhide:SetTop(135-self.recent_kills_panel:GetHeight() - 5)
  end
end